package tests;

import java.io.BufferedReader;
import java.io.InputStreamReader;

import suicideChess.*;
import suicideChess.Square.NotAValidSquare;

/**
 * @author djib
 * 
 * The purpose of this file is to test the Moves.java class and the BitBoard.java class
 * 
 * $LastChangedDate$
 * $LastChangedRevision$
 * $LastChangedBy$
 */

public class TestMoves {

	public static void main(String[] args) {
		BufferedReader moveInput = new BufferedReader(new InputStreamReader(System.in));
		
		BitBoardTest bitboard = new BitBoardTest();
		
		while (true) {
			try {
				/**
				 * Test of Move and Square class
				 */
				//String move = moveInput.readLine();
				//(new MoveTest(move)).display();
				//System.out.println((new BitBoard().squareToBitboardSquare(new Square(move))));
				//new SquareTest(move).display();
				//System.out.println(new Square(move));
				
				/**
				 * Test of the add function in class BitBoard
				 */
				
				String whereToAdd = moveInput.readLine();
				if (whereToAdd.startsWith("rm ")) {
					bitboard.rm(new Square(whereToAdd.substring(3)), new Piece(Piece.BLACK_PAWN));
				} else {
					bitboard.add(new Square(whereToAdd), new Piece(Piece.BLACK_PAWN));
				}
				bitboard.display(Piece.BLACK_PAWN);
				
			} catch (Exception err) {
				System.out.println(err);
				break;
	        }
		}
	}
}

class MoveTest extends Move {
	public MoveTest(String move) throws NotAValidMoveException, NotAValidSquare {
		super(move);
	}
	public void display() {
		System.out.println(" ");
		System.out.println("==== Move  ====");
		System.out.println("From square:"+fromSquare());
		System.out.println("To square:  "+toSquare());
		System.out.println((isPromotionMove() ? "Promotion:   "+getPromotionPiece() : "No Promotion"));
		System.out.println("===============");
		System.out.println(" ");
		System.out.println(" ");
	}
}

class SquareTest extends Square {
	public SquareTest(String square) throws NotAValidSquare {
		super(square);
	}
	public void display() {
		System.out.println(" ");
		System.out.println("==== Square ====");	
		System.out.println("Rank:   "+getRank());
		System.out.println("File:   "+getFile());
		System.out.println("FileNb: "+getFileNb());
		System.out.println("===============");
		System.out.println(" ");
		System.out.println(" ");
	}		
}

class BitBoardTest extends BitBoard {
	public void display(int whatToDisplay) {
		System.out.println(bitBoards[whatToDisplay]);
		for (int file = NB_OF_FILES; file >= 1; file--) {
			System.out.println("+-+-+-+-+-+-+-+-+");
			String display = "|";
			for (int rank=1; rank <= NB_OF_RANKS; rank++) {
				long mask = mapSquaresToBits[rank-1+(file-1)*NB_OF_RANKS];
				if ((bitBoards[whatToDisplay] & mask)==0) {
					display+=" |";
				} else {
					display+="1|"; 
				}
			}
			System.out.println(display);
		}
		System.out.println("+-+-+-+-+-+-+-+-+");
	}
	public void add (Square square, Piece piece) {
		addPiece(square, piece);
	}
	public void rm (Square square, Piece piece) {
		removePiece(square, piece);
	}
}